<template>
  <div>
    <div class="card card-custom p-5 gutter-b">
      <div class="card-body p-0">
        <div class="row">
          <div class="col-md-6 py-2 col-sm-12">
            <label for="input-large">Kode</label>

            <b-form-input
              id="input-large"
              size="lg"
              placeholder="Masukkan Kode"
              v-model="filter.code"
            ></b-form-input>
          </div>

          <div class="col-md-6 py-2 col-sm-12">
            <label for="input-large">Ruang Lingkup Design DMP</label>

            <b-form-input
              id="input-large"
              size="lg"
              placeholder="Masukkan Ruang Lingkup Design DMP"
              v-model="filter.name"
            ></b-form-input>
          </div>
        </div>

        <div class="d-flex justify-content-end">
          <button
            class="btn btn-primary btn-md"
            @click="getScopeOfDesigns(true)"
          >
            <i class="flaticon2-search-1"></i> Filter
          </button>
        </div>
      </div>
    </div>

    <div class="card card-custom card-stretch-fourth p-5 gutter-b">
      <div class="d-flex my-3 justify-content-start">
        <button
          class="btn btn-success btn-md"
          @click="showInputModal(null, 'Form Tambah Ruang Lingkup Design DMP')"
        >
          <i class="flaticon-add"></i> Tambah Ruang Lingkup Design DMP
        </button>
      </div>

      <div class="card-body p-0">
        <complete-table :loading="loading" :data="scopeOfDesigns">
          <template #header>
            <tr class="text-left">
              <th class="pl-7">Code</th>
              <th class="pl-7">Ruang Lingkup Design DMP</th>
              <th class="pl-7 text-center">Aksi</th>
            </tr>
          </template>

          <template #body>
            <template v-for="(scopeOfDesign, i) in scopeOfDesigns">
              <tr v-bind:key="i" class="border-0">
                <td class="pl-0 pt-8">
                  <span
                    class="ml-5 text-dark-75 font-weight-bolder d-block font-size-lg"
                  >
                    {{ scopeOfDesign.code }}
                  </span>
                </td>

                <td class="pl-0 pt-8">
                  <span
                    class="ml-5 text-dark-75 font-weight-bolder d-block font-size-lg"
                  >
                    {{ scopeOfDesign.name }}
                  </span>
                </td>

                <td class="pl-0 pt-8 text-center">
                  <a
                    class="btn btn-light-success font-weight-bolder font-size-sm"
                    @click="
                      showInputModal(
                        scopeOfDesign,
                        'Form Ubah Ruang Lingkup Design DMP',
                        false
                      )
                    "
                  >
                    <i class="flaticon-edit"></i>
                  </a>

                  <a
                    class="btn btn-light-danger font-weight-bolder font-size-sm ml-2"
                    @click="showDeleteModal(scopeOfDesign)"
                  >
                    <i class="flaticon-delete"></i>
                  </a>
                </td>
              </tr>
            </template>
          </template>
        </complete-table>
      </div>
    </div>

    <b-modal ref="input" hide-footer :title="modalTitle">
      <div class="d-block text-center">
        <form>
          <div class="row">
            <div class="col-md-12 py-2 col-sm-12 text-left">
              <label for="input-large">Code *</label>

              <b-form-input
                id="input-large"
                size="lg"
                placeholder="Masukkan Code"
                v-model="form.code"
                :disabled="!isCreate"
              ></b-form-input>
            </div>
            <div class="col-md-12 py-2 col-sm-12 text-left">
              <label for="input-large">Ruang Lingkup Design DMP *</label>

              <b-form-input
                id="input-large"
                size="lg"
                placeholder="Masukkan Nama Ruang Lingkup Design DMP"
                v-model="form.name"
              ></b-form-input>
            </div>
          </div>
        </form>

        <div class="d-flex mt-2">
          <b-button
            :disabled="loading"
            class="btn btn-success mr-2"
            block
            @click="isCreate ? saveScopeOfDesign() : updateScopeOfDesign()"
          >
            Simpan
          </b-button>

          <b-button
            :disabled="loading"
            class="btn btn-secondary mt-0"
            block
            @click="closeInputModal"
          >
            Batal
          </b-button>
        </div>
      </div>
    </b-modal>

    <b-modal ref="delete" hide-footer title="Warning">
      <div class="d-block text-center">
        <div class="row">
          <div class="col-md-12 py-2 col-sm-12 text-left">
            <label for="input-large"
              >Ruang Lingkup Design DMP Akan Dihapus</label
            >
          </div>
        </div>
        <div class="d-flex mt-2">
          <b-button
            :disabled="loading"
            class="btn btn-success mr-2"
            @click="deleteScopeOfDesign"
            block
          >
            Hapus
          </b-button>

          <b-button
            class="btn btn-secondary mt-0"
            block
            @click="closeDeleteModal"
            :disabled="loading"
          >
            Batal
          </b-button>
        </div>
      </div>
    </b-modal>
  </div>
</template>

<script>
import { SET_BREADCRUMB } from "@/core/services/store/breadcrumbs.module";
import { mapState } from "vuex";
import CompleteTable from "../../content/widgets/advance-table/CompleteTable";
import { arrayMoreThanOne } from "../../../core/helper/array-validation.helper";
import {
  DELETE_SCOPE_OF_DESIGN,
  GET_SCOPE_OF_DESIGN,
  SAVE_SCOPE_OF_DESIGN,
  UPDATE_SCOPE_OF_DESIGN
} from "../../../core/services/store/scope-of-design.module";

export default {
  components: { CompleteTable },

  data() {
    return {
      filter: {
        code: null,
        name: null
      },
      currentItem: null,
      modalTitle: null,
      form: {
        code: null,
        name: null
      },
      isCreate: true
    };
  },

  computed: {
    ...mapState({
      loading: state => state.scopeOfDesign.loading,
      scopeOfDesigns: state => state.scopeOfDesign.scopeOfDesigns?.data
    })
  },

  methods: {
    showInputModal(scopeOfDesign, modalTitle, isCreate = true) {
      this.currentItem = scopeOfDesign;

      this.form = {
        code: scopeOfDesign?.code,
        name: scopeOfDesign?.name
      };

      this.modalTitle = modalTitle;

      this.isCreate = isCreate;

      this.$refs["input"].show();
    },

    showDeleteModal(scopeOfDesign) {
      this.currentItem = scopeOfDesign;

      this.$refs["delete"].show();
    },

    closeInputModal() {
      this.$refs["input"].hide();
    },

    closeDeleteModal() {
      this.$refs["delete"].hide();
    },

    getScopeOfDesigns(filter = false) {
      if (!arrayMoreThanOne(this.scopeOfDesigns) || filter) {
        this.$store.dispatch(GET_SCOPE_OF_DESIGN, {
          params: {}
        });
      }
    },

    deleteScopeOfDesign() {
      this.$store
        .dispatch(DELETE_SCOPE_OF_DESIGN, {
          code: this.currentItem?.code
        })
        .then(() => {
          this.closeDeleteModal();
        });
    },

    saveScopeOfDesign() {
      this.$store.dispatch(SAVE_SCOPE_OF_DESIGN, this.form).then(() => {
        this.closeInputModal();
      });
    },

    updateScopeOfDesign() {
      this.$store.dispatch(UPDATE_SCOPE_OF_DESIGN, this.form).then(() => {
        this.closeInputModal();
      });
    }
  },

  mounted() {
    this.$store.dispatch(SET_BREADCRUMB, [
      { title: "Ruang Lingkup Design DMP" }
    ]);

    this.getScopeOfDesigns();
  }
};
</script>
